<template>
  <div class="semester-manage">
    <div class="part-box part-box-filter part-box-flex">
      <div>
        <el-button
          v-if="checkPrivilege('button', 'select')"
          type="primary"
          @click="toPage(1)"
          >查询</el-button
        >
      </div>
      <div class="part-box-action">
        <el-button
          v-if="checkPrivilege('button', 'add')"
          type="primary"
          icon="el-icon-circle-plus-outline"
          @click="toAdd"
          >新增学期</el-button
        >
      </div>
    </div>
    <div class="part-box part-box-pad">
      <el-table ref="TableList" :data="dataList">
        <el-table-column
          type="index"
          label="序号"
          width="70"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column prop="semesterName" label="学期"></el-table-column>
        <el-table-column prop="inUsed" label="当前学期">
          <span
            :class="{ 'color-success': scope.row.inUsed }"
            slot-scope="scope"
            >{{ scope.row.inUsed ? "是" : "否" }}</span
          >
        </el-table-column>
        <el-table-column class-name="action-column" label="操作" width="200px">
          <template slot-scope="scope">
            <el-button
              v-if="checkPrivilege('link', 'edit') && !scope.row.inUsed"
              class="btn-primary"
              type="text"
              @click="setUsed(scope.row)"
              >设置为当前学期</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'edit')"
              class="btn-primary"
              type="text"
              @click="toEdit(scope.row)"
              >编辑</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'delete')"
              class="btn-danger"
              type="text"
              @click="toDelete(scope.row)"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          background
          layout="total,prev, pager, next"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
        >
        </el-pagination>
      </div>
    </div>

    <modify-semester
      :instance="curRow"
      @modified="getList"
      ref="ModifySemester"
    ></modify-semester>
  </div>
</template>

<script>
import { semesterListQuery, deleteSemester, semesterSetInUsed } from "../api";
import ModifySemester from "../components/ModifySemester";

export default {
  name: "semester-manage",
  components: { ModifySemester },
  data() {
    return {
      filter: {},
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      dataList: [],
      curRow: {}
    };
  },
  mounted() {
    this.getList();
  },
  methods: {
    async getList() {
      if (!this.checkPrivilege("list", "list")) return;

      const datas = {
        ...this.filter,
        pageNumber: this.current,
        pageSize: this.size
      };
      const data = await semesterListQuery(datas);
      this.dataList = data.records;
      this.total = data.total;
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    toAdd() {
      this.curRow = {};
      this.$refs.ModifySemester.open();
    },
    toEdit(row) {
      this.curRow = row;
      this.$refs.ModifySemester.open();
    },
    async toDelete(row) {
      const result = await this.$confirm(
        `确定要删除学期【${row.semesterName}】吗?`,
        "提示",
        {
          type: "warning"
        }
      ).catch(() => {});
      if (result !== "confirm") return;

      await deleteSemester(row.id);
      this.$message.success("删除成功！");
      this.deletePageLastItem();
    },
    async setUsed(row) {
      const result = await this.$confirm(
        `确定要将学期【${row.semesterName}】设置成当前学期吗？`,
        "提示",
        {
          type: "warning"
        }
      ).catch(() => {});
      if (result !== "confirm") return;

      await semesterSetInUsed(row.id);

      this.getList();
      this.$message.success("设置成功！");
    }
  }
};
</script>
